/*
 * MDC Desktop Client Created on 13-May-2005
 */
package org.mdcog.client.desktop.gui.controllers;

import java.util.Collection;
import java.util.Vector;

import org.mdcog.client.desktop.model.ResourceItem;

/**
 * This class implements the methods that control how the add resource item
 * dialog interacts with the model
 * 
 * @uml.dependency supplier="org.mdcog.client.desktop.model.ResourceItem" stereotypes="Basic::Create"
 */

public class AddNewResourceItemDialogController extends Controller
{

    /**
     * Stores a reference to the all the resource items that were created during
     * the lifecycle of dialog. This is basically the model for the dialog.
     */
    private Vector createdResources = null;

    /**
     * Constructor
     */
    public AddNewResourceItemDialogController()
    {
        createdResources = new Vector();       
    }

    /**
     * Called to get all the resource items that were created by the user
     * 
     * @return the list of resources that were created during the dilogs life
     *         cycle
     * 
     * @uml.property name="createdResources"
     */
    public Collection getCreatedResources() {
        return createdResources;
    }

    
    /**
     * Add the item to the list of return items
     * @param item the resource to add
     */
    public void addResourceItem(ResourceItem item)
    {
        createdResources.add(item);
    }
}
