/*
 * MDC Desktop Client Created on 16-May-2005
 */
package org.mdcog.client.desktop.gui.controllers;

/**
 * This interface specifies the methods that a controller must implement in
 * order for the GUI to handle the resource Item grid buttons. The
 * interface exists so that a general panel can be used with different under
 * pinning controllers depending on where the panel is being used.
 */
public interface ResourceItemButtonControllerInterface
{

    /**
     * Called when the open Local URL button clicked at specified row
     * 
     * @param row Zero based index of the row to open
     */
    public void openLocalURL(int row);

    /**
     * Called when the open Web URL button clicked at specified row
     * 
     * @param row Zero based index of the row to open
     */
    public void openWebURL(int row);

    /**
     * Called when the open Open URL button clicked at specified row
     * 
     * @param row Zero based index of the row to open
     */
    public void openOpenURL(int row);
    /**
     * Called when the annotation button clicked at specified row
     * 
     * @param row Zero based index of the row to open
     */
    public void openResourceItemAnnotation(int row);

}
