/*
 * MDC Desktop Client Created on 06-May-2005
 */
package org.mdcog.client.desktop.gui.controllers;

/**
 * This interface specifies the methods that a controller must implement in
 * order for the GUI to update and retrieve resource list header data. The
 * interface exists so that a general panel can be used with different under
 * pinning controllers depending on where the panel is being used.
 */
public interface ResourceListHeaderControllerInterface
{

    /**
     * Open the annotation dialog for the lists annotation
     */
    public void openResourceListAnnotation();

    /**
     * Update the currently selected lists author
     * 
     * @param author
     * 
     * @uml.property name="resourceListAuthor"
     */
    public void setResourceListAuthor(String author);

    /**
     * Update the currently selected lists owner
     * 
     * @param owner
     * 
     * @uml.property name="resourceListOwner"
     */
    public void setResourceListOwner(String owner);

    /**
     * Update the currently selected lists title
     * 
     * @param title
     * 
     * @uml.property name="resourceListTitle"
     */
    public void setResourceListTitle(String title);

    /**
     * Get the currently selected lists author
     * 
     * @return The author
     * 
     * @uml.property name="resourceListAuthor"
     */
    public String getResourceListAuthor();

    /**
     * Get the currently selected lists owner
     * 
     * @return The Owner
     * 
     * @uml.property name="resourceListOwner"
     */
    public String getResourceListOwner();

    /**
     * Get the currently selected lists title
     * 
     * @return The title
     * 
     * @uml.property name="resourceListTitle"
     */
    public String getResourceListTitle();

    
    /**
     * Get the currently selected lists creation date
     * 
     * @return The date
     */
    public String getResourceListCreationDate();

}
