/*
 * MDC Desktop Client Created on 22-Apr-2005
 */
package org.mdcog.client.desktop.gui.menus;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JMenuItem;

import org.mdcog.client.desktop.gui.controllers.SearchTabController;
import org.mdcog.client.desktop.gui.images.MDCIcons;

/**
 * This class represents the pop up menu shown when an item is clicked on the
 * library resource list item
 */
public class SearchMyListResourceGridPopUpMenu extends javax.swing.JPopupMenu
{

    /**
     * Stores a reference to the delete menu item
     */
    private JMenuItem deleteItem;

    /**
     * Stores a reference to the save menu item
     */
    private JMenuItem saveItem;

    /**
     * Stores a reference to the add menu item
     */
    private JMenuItem addItem;

    /**
     * Stores a reference to the rows selected before pop up was shown
     */
    private int[] rowsSelected;

    /**
     * Constructor for the menu.
     * 
     * @param rowsSelected The rows currently slected that the pop up is against
     */
    public SearchMyListResourceGridPopUpMenu(int[] rowsSelected)
    {
        this.rowsSelected = rowsSelected;

        // create menu
        this.add(getSaveMenuItem());
        this.add(getAddMenuItem());
        this.add(getDeleteMenuItem());
    }

    /**
     * Gets and constructs the add menu item
     * 
     * @return the created menu item
     */
    private JMenuItem getAddMenuItem()
    {
        addItem = new JMenuItem("Add", MDCIcons.ADDRESOURCEITEM_ICON);
        addItem.setMnemonic(KeyEvent.VK_A);
        addItem.setDisplayedMnemonicIndex(0);
        addItem.addActionListener(new ActionListener()
        {

            public void actionPerformed(ActionEvent e)
            {
                SearchTabController.getInstance().createResourceItems();
            }
        });
        return addItem;
    }

    /**
     * Gets and constructs the save menu item
     * 
     * @return the created menu item
     */
    private JMenuItem getSaveMenuItem()
    {
        saveItem = new JMenuItem("Save to My Library", MDCIcons.SAVERESOURCEITEM_ICON);
        saveItem.setMnemonic(KeyEvent.VK_S);
        saveItem.setDisplayedMnemonicIndex(0);
        saveItem.addActionListener(new ActionListener()
        {

            public void actionPerformed(ActionEvent e)
            {
                SearchTabController.getInstance().saveToMyLibrary(rowsSelected);
            }
        });
        return saveItem;
    }

    /**
     * Gets and constructs the delete menu item
     * 
     * @return the created menu item
     */
    private JMenuItem getDeleteMenuItem()
    {
        deleteItem = new JMenuItem("Delete", MDCIcons.DELETE_ICON);
        deleteItem.setMnemonic(KeyEvent.VK_D);
        deleteItem.setDisplayedMnemonicIndex(0);
        deleteItem.addActionListener(new ActionListener()
        {

            public void actionPerformed(ActionEvent e)
            {
                SearchTabController.getInstance().deleteResourceItemsFromMyList(rowsSelected);
            }
        });
        return deleteItem;
    }

}
