/*
 * MDC Desktop Client Created on 23-Jun-2005
 */
package org.mdcog.client.desktop.gui.models;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.table.TableColumn;

/**
 * This class is a listner for the columns pop up menu items as it is
 * dynamically generated. It calls back on the registered table format to show
 * or hide the column it is associated to
 */
public class ColumnPopUpMenuListener implements ActionListener
{

    /**
     * Stores a reference to the checkbox menu item this listener is registered against
     */
    private JCheckBoxMenuItem menuItem = null;

    /**
     * Stores a reference to the column this this listener is registered against 
     */
    private TableColumn column = null;
    

    /**
     * Stores a reference to the column displayer
     */
    private ColumnDisplayInterface displayer = null;

    /**
     * Constructor
     * @param menuItem The check box menu item representing the column
     * @param displayer The displayer for showing the column
     * @param col The column being represented
     */
    public ColumnPopUpMenuListener(JCheckBoxMenuItem menuItem, ColumnDisplayInterface displayer, TableColumn col)
    {
        this.menuItem = menuItem;
        this.column = col;
        this.displayer = displayer;
    }

    /** 
     * Called when the item is clicked
     * @param e The action driving the event
     */
    public void actionPerformed(ActionEvent e)
    {
        // ask the displayer to show or hide the column depending upon the menu state
        displayer.showColumn(column, menuItem.getState());
    }

}
