/*
 * MDC Desktop Client Created on 11-May-2005
 */
package org.mdcog.client.desktop.gui.models;

import java.io.File;
import java.util.ArrayList;

import org.mdcog.client.desktop.model.MDCLibraryModel;

/**
 * This class is used by the standard file open/save dialog to allow the user to
 * filter only on the MDC client library file extension
 */
public class MDCLibraryFileFilter extends MDCFileFilter
{

    /**
     * Public constructor that sets up the Filter super class
     */
    public MDCLibraryFileFilter()
    {
        super("MDC libraries (*." + MDCLibraryModel.LIBRARY_FILE_EXTENSION + ")");
        ArrayList extensions = new ArrayList();
        extensions.add(MDCLibraryModel.LIBRARY_FILE_EXTENSION);
        setExtensions(extensions);
    }
    

    /**
     * This method returns checks the file extension of the file to check if it
     * is a library file
     * 
     * @param file The file to check
     * @return True if file has the correct extension
     */
    public static boolean isLibraryFile(File file)
    {
        return getExtension(file).equalsIgnoreCase(MDCLibraryModel.LIBRARY_FILE_EXTENSION);
    }

  
      
}
