/*
 * MDC Desktop Client Created on 27-Apr-2005
 */
package org.mdcog.client.desktop.gui.models;

import java.awt.datatransfer.DataFlavor;

import javax.swing.JComponent;
import javax.swing.TransferHandler;

/**
 * This is the base class for all ReosurceItem transfer handlers. It provides
 * the basic methods that all handlers must support as well as defing the basic
 * supported formats
 */
public class ResourceItemTransferHandler extends TransferHandler
{

    /**
     * Stores a reference to the supported format
     */
    protected DataFlavor supportedDataFlavor = null;

    /**
     * Constructor 
     */
    public ResourceItemTransferHandler()
    {
        try
        {
            supportedDataFlavor = new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType);
        }
        catch (ClassNotFoundException e)
        {
            // should nerver occurr
            e.printStackTrace();
        }
    }

    /**
     * Returns the actions allowed by the source
     * @param component The component the transfer is against
     * @return The actions supported (COPY & MOVE)
     */
    public int getSourceActions(JComponent component)
    {
        return COPY_OR_MOVE;
    }

}
