/*
 * MDC Desktop Client Created on 22-Apr-2005
 */
package org.mdcog.client.desktop.gui.models;

import ca.odell.glazedlists.EventList;
import ca.odell.glazedlists.gui.TableFormat;
import ca.odell.glazedlists.swing.EventTableModel;

/**
 * This class defines the resource list table model. It simply used the glazed
 * lists EventTableModel but overides the cell editable method to return false
 * if first row *
 * 
 * @see <a href="http://publicobject.com/glazedlists">Glazed Lists HomePage </a>
 */
public class ResourceListTableModel extends EventTableModel
{

    /**
     * Constructor that simply passes data to super constructor
     * 
     * @param eventList The event list for the model
     * @param format The table format model
     */
    public ResourceListTableModel(EventList eventList, TableFormat format)
    {
        super(eventList, format);
    }

    /**
     * return boolean to indicate if cell is editable, this overloads super
     * class that is base object specific because only the first row is not
     * editable
     * 
     * @param row the cell row
     * @param column the cell column
     * @return true if not first row
     */
    public boolean isCellEditable(int row, int column)
    {
        // all rows except the all resources list is editable
        return row != 0;
    }

}
