/*
 * MDC Desktop Client Created on 20-Apr-2005
 */
package org.mdcog.client.desktop.gui.panels;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JSplitPane;

/**
 * This class implements the My library tab splitter <br/><br/>Note - It was
 * partially created using the Eclipse Visual Editor plugin
 */
public class MyLibaryTabPanel extends JPanel
{

    /**
     * Stores a reference to the resource splitter
     */
    private JSplitPane resourceListSplitter = null;

    /**
     * Stores a reference to the left resource list panel
     * 
     * @uml.property name="myResourceListsPanel"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private MyLibraryResourceListsPanel myResourceListsPanel = null;

    /**
     * Stores a reference to the right resource item grid panel
     * 
     * @uml.property name="myLibraryResourceGridPanel"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private MyLibraryResourceGridPanel myLibraryResourceGridPanel = null;


    /**
     * This is the default constructor
     */
    public MyLibaryTabPanel()
    {
        super();
        initialize();
    }

    /**
     * This method initializes the panel
     * 
     * @return void
     */
    private void initialize()
    {
        this.setLayout(new BorderLayout());
        this.setSize(493, 291);

        this.add(getResourceListSplitter(), java.awt.BorderLayout.CENTER);
    }

    /**
     * This method initializes the splitter pane
     * 
     * @return javax.swing.JSplitPane
     * 
     * @uml.property name="resourceListSplitter"
     */
    private JSplitPane getResourceListSplitter() {
        if (resourceListSplitter == null) {
            resourceListSplitter = new JSplitPane();
            resourceListSplitter.setComponentOrientation(java.awt.ComponentOrientation.LEFT_TO_RIGHT);
            resourceListSplitter.setLeftComponent(getMyResourceListsPanel());
            resourceListSplitter.setDividerLocation(200);
            resourceListSplitter.setRightComponent(getMyLibraryResourceGridPanel());
        }
        return resourceListSplitter;
    }

    /**
     * This method initializes resource list panel
     * 
     * @return org.mdc.client.desktop.gui.MyResourceListsPanel
     * 
     * @uml.property name="myResourceListsPanel"
     */
    private MyLibraryResourceListsPanel getMyResourceListsPanel() {
        if (myResourceListsPanel == null) {
            myResourceListsPanel = new MyLibraryResourceListsPanel();
        }
        return myResourceListsPanel;
    }

    /**
     * This method initializes resource grid panel
     * 
     * @return org.mdc.client.desktop.gui.panels.MyLibraryResourceGridPanel
     * 
     * @uml.property name="myLibraryResourceGridPanel"
     */
    private MyLibraryResourceGridPanel getMyLibraryResourceGridPanel() {
        if (myLibraryResourceGridPanel == null) {
            myLibraryResourceGridPanel = new MyLibraryResourceGridPanel();
        }
        return myLibraryResourceGridPanel;
    }

} //  @jve:decl-index=0:visual-constraint="10,10"
