/*
 * MDC Desktop Client Created on 02-May-2005
 */
package org.mdcog.client.desktop.gui.panels;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import org.mdcog.client.desktop.gui.controllers.SearchTabController;
import org.mdcog.client.desktop.gui.menus.SearchResultsResourceTabPopUpMenu;

/**
 * This class implements the search results main panel <br/><br/>Note - It was
 * partially created using the Eclipse Visual Editor plugin
 */
public class SearchResultsPanel extends JPanel
{

    /**
     * Stores a reference to the results tab pane
     */
    private JTabbedPane resultTabPane = null;

    /**
     * Stores a reference to the controller for the panel
     * 
     * @uml.property name="controller"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private SearchTabController controller = null;

    /**
     * Stores a reference to the search criteria panel
     */
    private SearchCriteriaPanel searchCriteriaPanel = null; //  @jve:decl-index=0:visual-constraint="274,8"

    /**
     * Stores a reference to the results panel
     */
    private JPanel resultsPanel = null;

    /**
     * This is the default constructor
     */
    public SearchResultsPanel()
    {
        super();
        initialize();
    }

    /**
     * This method initializes this panel
     */
    private void initialize()
    {
        controller = SearchTabController.getInstance();
        this.setSize(1158, 290);
        this.setLayout(new BorderLayout());
        this.add(getSearchCriteriaPanel(), java.awt.BorderLayout.NORTH);
        this.add(getResultsPanel(), java.awt.BorderLayout.CENTER);
    }

    /**
     * This method initializes the tabbed pane
     * 
     * @return javax.swing.JTabbedPane
     * @uml.property name="resultTabPane"
     */
    private JTabbedPane getResultTabPane()
    {
        if (resultTabPane == null)
        {
            resultTabPane = new JTabbedPane();
            controller.setResultsTabPane(resultTabPane);
            resultTabPane.addMouseListener(new java.awt.event.MouseAdapter()
            {

                public void mouseReleased(java.awt.event.MouseEvent e)
                {
                    // check if context popup event
                    if (e.isPopupTrigger())
                    {
                        //only show popup if we have tabs displayed
                        if (resultTabPane.getTabCount() > 0)
                        {
                            SearchResultsResourceTabPopUpMenu popup = new SearchResultsResourceTabPopUpMenu(controller,
                                    resultTabPane.getSelectedIndex());
                            popup.show(resultTabPane, e.getX(), e.getY());
                        }
                    }
                    else
                    {
                        super.mouseReleased(e);
                    }
                }
            });
        }
        return resultTabPane;
    }

    /**
     * This method initializes searchCriteriaPanel
     * 
     * @return org.mdcog.client.desktop.gui.panels.SearchCriteriaPanel
     */
    private SearchCriteriaPanel getSearchCriteriaPanel()
    {
        if (searchCriteriaPanel == null)
        {
            searchCriteriaPanel = new SearchCriteriaPanel();
        }
        return searchCriteriaPanel;
    }

    /**
     * This method initializes jPanel
     * 
     * @return javax.swing.JPanel
     */
    private JPanel getResultsPanel()
    {
        if (resultsPanel == null)
        {
            resultsPanel = new JPanel();
            resultsPanel.setLayout(new BorderLayout());
            resultsPanel.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.SoftBevelBorder.LOWERED));
            resultsPanel.add(getResultTabPane(), java.awt.BorderLayout.CENTER);
        }
        return resultsPanel;
    }
} //  @jve:decl-index=0:visual-constraint="10,10"
