/*
 * MDC Desktop Client Created on 20-Apr-2005
 */
package org.mdcog.client.desktop.gui.panels;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JSplitPane;

/**
 * This class implements the search tab panel that creates the main panels
 * <br/><br/>Note - It was partially created using the Eclipse Visual Editor
 * plugin
 * 
 * @uml.dependency supplier="org.mdcog.client.desktop.gui.panels.SearchMyListGridPanel" stereotypes="Basic::Instantiate"
 */

public class SearchTabPanel extends JPanel
{

    /**
     * Stores a reference to the results splitter pane
     */
    private JSplitPane resultsSplitters = null;

    /**
     * Stores a reference to the top search results panel
     * 
     * @uml.property name="searchResultsPanel"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private SearchResultsPanel searchResultsPanel = null;

    /**
     * Stores a reference to the bottom my list Grid panel
     * 
     * @uml.property name="searchMyListGridPanel"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private SearchMyListGridPanel searchMyListGridPanel = null;


    /**
     * This is the default constructor
     */
    public SearchTabPanel()
    {
        super();
        initialize();
    }

    /**
     * This method initializes this panel
     */
    private void initialize()
    {
        this.setLayout(new BorderLayout());
        this.setSize(1050, 267);
        this.add(getResultsSplitters(), java.awt.BorderLayout.CENTER);
    }

    /**
     * This method initializes the splitter pane
     * 
     * @return javax.swing.JSplitPane
     * 
     * @uml.property name="resultsSplitters"
     */
    private JSplitPane getResultsSplitters() {
        if (resultsSplitters == null) {
            resultsSplitters = new JSplitPane();
            resultsSplitters.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
            resultsSplitters.setTopComponent(getSearchResultsPanel());
            resultsSplitters.setBottomComponent(getSearchMyListPanel());
            resultsSplitters.setDividerLocation(375);
        }
        return resultsSplitters;
    }

    /**
     * This method initializes search results top splitter panel
     * 
     * @return org.mdc.client.desktop.gui.panels.SearchResultsPanel
     * 
     * @uml.property name="searchResultsPanel"
     */
    private SearchResultsPanel getSearchResultsPanel() {
        if (searchResultsPanel == null) {
            searchResultsPanel = new SearchResultsPanel();
        }
        return searchResultsPanel;
    }

    /**
     * This method initializes the bottom my list grid panel
     * 
     * @return org.mdc.client.desktop.gui.panels.SearchMyListGridPanel
     * 
     * @uml.property name="searchMyListGridPanel"
     */
    private SearchMyListGridPanel getSearchMyListPanel() {
        if (searchMyListGridPanel == null) {
            searchMyListGridPanel = new SearchMyListGridPanel();
        }
        return searchMyListGridPanel;
    }

} //  @jve:decl-index=0:visual-constraint="10,10"
