/*
 * MDC Desktop Client Created on 18-May-2005
 */
package org.mdcog.client.desktop.model;

/**
 * This is the super class that any model should implement. It provides the
 * functionality to check if the model has become dirty and hence needs saving
 */
public class MDCModel extends Object
{

    /**
     * Stores a reference to the isDirty flag that indicates if changes were
     * made since it was last changed
     */
    private boolean isDirty = false;

    /**
     * Sets the flag to indicate the model is now dirty
     */
    protected void setDirty()
    {
        isDirty = true;
    }

    /**
     * Sets the flag to indicate the model is now clean and hence been saved.
     * Can be overloaded if need to clean nested objects.
     */
    public void setClean()
    {
        isDirty = false;
    }

    /**
     * Allows a caller to check if the model is dirty.Can be overloaded if need
     * to clean nested objects.
     * 
     * @return true if the model is dirty and needs saving
     * 
     * @uml.property name="isDirty"
     */
    public boolean isDirty() {
        return isDirty;
    }

}
