/*
 * MDC Desktop Client
 * Created on 10-Jun-2005 
 */
package org.mdcog.client.desktop.utils;

import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;


/**
 * This class provides static utility classes to format dates for the MDC client
 */
public class MDCDate
{
    /**
     * Stores a reference to the MDC date formatter
     */
    public static SimpleDateFormat DATE_FORMATTER = new SimpleDateFormat("dd/MM/yyyy");
    /**
     * Returns the MDC string version of the current date 
     * @return The current date as a string
     */
    public static String getCurrentDate()
    {
        // return the current date formatted for MDC
        return DATE_FORMATTER.format(new GregorianCalendar().getTime());
    }
}
