/**
 *  Copyright: Copyright (c) 2004
 *  Company: Oxford University
 * 
 * Usage:
 *  1) construct OpenURL object
 *  2) set values for openURL eg. set authors first & last name with setAufirst & setAulast
 *  3) create openURL with the method 'generateOpenURL()'
 *
 *@author     David Gilks
 *@version    1.0
 * moved to org.mdcog.util.resolver package by Adrian Cuthbertson 2005-02-15
 */
package org.mdcog.util.resolver;



/**
 * @author dgilks
 * Created on: Oct 8, 2004 
 * 
 */
public class OpenURL {

   /**
    * constructor
    *
    */
   public OpenURL() {
      // initialise fields
      setAufirst("");
      setAulast("");
      setAtitle("");
      setStitle("");
      setTitle("");
      setCoden("");
      setEissn("");
      setIsbn("");
      setIssn("");      
      
//      setTitle("");
//      setDescription("");
//      setClassification(new String[0]);
//      setContribentity(new String[0]);
//      setContribrole(new String[0]);
//      setKeyword(new String[0]);
//      setLang(new String[0]);
//      setResourcetype(new String[0]);
//      setStatus(new String[0]);
//      setSubject(new String[0]);

      setBaseResolver("" );
   }

   /** creates an OpenURL from the base resolver & values set.
    * An empty string is returned if error occured
    *
    * @return openURL
    */
   public String generateOpenURL() {
      String error;
      String returnUrl;
      String data = "";

      if (getBaseResolver().length() == 0) {
         error = "Base resolver not set";
         return new String();         
      }
            
      if (getAufirst().length() > 0) {
         data += prependDataString(data) + auFirstTag + getAufirst();                 
      }
      
      if (getAulast().length() > 0) {    
         data += prependDataString(data) + auLastTag + getAulast();              
      }    
      
      if (getAtitle().length() > 0) {    
          data += prependDataString(data) + atitleTag + getAtitle();              
       }    
      
      if (getStitle().length() > 0) {    
          data += prependDataString(data) + stitleTag + getStitle();              
       }     

      if (getTitle().length() > 0) {    
          data += prependDataString(data) + titleTag + getTitle();              
       }          
      
      if (getCoden().length() > 0) {    
          data += prependDataString(data) + codenTag + getCoden();              
       }   
      
      if (getEissn().length() > 0) {    
          data += prependDataString(data) + eissnTag + getEissn();              
       }            
      
      if (getIssn().length() > 0) {    
          data += prependDataString(data) + issnTag + getIssn();              
       }  
      
      if (getIsbn().length() > 0) {    
          data += prependDataString(data) + isbnTag + getIsbn();              
       }             

      /*if (getTitle().length() > 0) {
         data += prependDataString(data) + beginTitleTag + getTitle() + endTitleTag;
      }
      
      if (getDescription().length() > 0) {
         data += prependDataString(data) +  beginDescTag + getDescription() + endDescTag;
      }
      */
      
/*      String pidData = getPidData();
      if (pidData.length() > 0) {
          data += prependDataString(data) + pidData;
      }
*/
      returnUrl = getBaseResolver() + data;
      return returnUrl;
   }
         
/*   private String getPidData() {
      String pidData = "";
      
      if (getClassification().length > 0) {         
          pidData += prependDataString(pidData) + beginClassificationTag + concatStringArray(getClassification()) + endClassificationTag;
      }
      
      if (getContribrole().length > 0) {
          pidData += prependDataString(pidData) + beginContribRoleTag + concatStringArray(getContribrole()) + endContribRoleTag;
      }
      
      if (getContribentity().length > 0) {
          pidData += prependDataString(pidData) + beginContribEntityTag + concatStringArray(getContribentity()) + endContribEntityTag;
      }
      
      if (getKeyword().length > 0) {
          pidData += prependDataString(pidData) + beginKeywordTag + concatStringArray(getKeyword()) + endKeywordTag;          
      }
      
      if (getLang().length > 0) {
          pidData += prependDataString(pidData) + beginLangTag + concatStringArray(getLang()) + endLangTag;
      }
      
      if (getResourcetype().length > 0) {
          pidData += prependDataString(pidData) + beginResourcetypeTag + concatStringArray(getResourcetype()) + endResourcetypeTag;
      }
      
      if (getStatus().length > 0) {
          pidData += prependDataString(pidData) + beginStatusTag + concatStringArray(getStatus()) + endStatusTag;      
      }
      
      if (getSubject().length > 0) {
          pidData += prependDataString(pidData) + beginSubjectTag + concatStringArray(getSubject()) + endSubjectTag;
      }
      
    return  (getBasePid() + pidData);
} */

private String prependDataString(String data) {
    if (data.length() > 0) {
       return "&";
    }
    return "";
}

    /**
     * 
     * @uml.property name="baseResolver"
     */
    public void setBaseResolver(String baseResolver) {
        this.baseResolver = baseResolver;
    }

    /**
     * 
     * @uml.property name="basePid"
     */
    public static String getBasePid() {
        return basePid;
    }

    /**
     * 
     * @uml.property name="aufirst"
     */
    private String getAufirst() {
        return aufirst;
    }

    /**
     * 
     * @uml.property name="aufirst"
     */
    public void setAufirst(String aufirst) {
        this.aufirst = aufirst;
    }

    /**
     * 
     * @uml.property name="aulast"
     */
    public String getAulast() {
        return aulast;
    }

    /**
     * 
     * @uml.property name="aulast"
     */
    public void setAulast(String aulast) {
        this.aulast = aulast;
    }

    /**
     * 
     * @uml.property name="baseResolver"
     */
    public String getBaseResolver() {
        return baseResolver;
    }

    /**
     * 
     * @uml.property name="atitle"
     */
    public void setAtitle(String atitle) {
        this.atitle = atitle;
    }

    /**
     * 
     * @uml.property name="coden"
     */
    public void setCoden(String coden) {
        this.coden = coden;
    }

    /**
     * 
     * @uml.property name="eissn"
     */
    public void setEissn(String eissn) {
        this.eissn = eissn;
    }

    /**
     * 
     * @uml.property name="isbn"
     */
    public void setIsbn(String isbn) {
        this.isbn = isbn;
    }

    /**
     * 
     * @uml.property name="issn"
     */
    public void setIssn(String issn) {
        this.issn = issn;
    }

    /**
     * 
     * @uml.property name="stitle"
     */
    public void setStitle(String stitle) {
        this.stitle = stitle;
    }

    /**
     * 
     * @uml.property name="title"
     */
    public void setTitle(String title) {
        this.title = title;
    }

/**
 * 
 * @uml.property name="atitle"
 */
public String getAtitle() {
    return this.atitle;
}

/**
 * 
 * @uml.property name="coden"
 */
public String getCoden() {
    return this.coden;
}

/**
 * 
 * @uml.property name="eissn"
 */
public String getEissn() {
    return this.eissn;
}

/**
 * 
 * @uml.property name="isbn"
 */
public String getIsbn() {
    return this.isbn;
}

/**
 * 
 * @uml.property name="issn"
 */
public String getIssn() {
    return this.issn;
}

/**
 * 
 * @uml.property name="stitle"
 */
public String getStitle() {
    return this.stitle;
}

/**
 * 
 * @uml.property name="title"
 */
public String getTitle() {
    return this.title;
}

   /*   public String[] getClassification() {
      return classification;
   }
   public void setClassification(String[] classification) {
      this.classification = classification;
   }
   public String[] getContribentity() {
      return contribentity;
   }
   public void setContribentity(String[] contribentity) {
      this.contribentity = contribentity;
   }
   public String[] getContribrole() {
      return contribrole;
   }
   public void setContribrole(String[] contribrole) {
      this.contribrole = contribrole;
   }
   public String getDescription() {
      return description;
   }
   public void setDescription(String description) {
      this.description = description;
   }
   public String[] getKeyword() {
      return keyword;
   }
   public void setKeyword(String[] keyword) {
      this.keyword = keyword;
   }
   public String[] getLang() {
      return lang;
   }
   public void setLang(String[] lang) {
      this.lang = lang;
   }
   public String[] getResourcetype() {
      return resourcetype;
   }
   public void setResourcetype(String[] resourcetype) {
      this.resourcetype = resourcetype;
   }
   public String[] getStatus() {
      return status;
   }
   public void setStatus(String[] status) {
      this.status = status;
   }
   public String[] getSubject() {
      return subject;
   }
   public void setSubject(String[] subject) {
      this.subject = subject;
   }
   public String getTitle() {
      return title;
   }
   public void setTitle(String title) {
      this.title = title;
   }
*/   
   
   /** concatenate the contents of the string array using an '&' as the separator
    * 
    * @param myArray
    * @return String
    */
   private String concatStringArray(String[] myArray) {
      String myString = "";
     // System.out.println("string array length: "+ myArray.length);
      
      for (int i=0; i < myArray.length; i++) {
         myString += prependDataString(myString);
       //  System.out.println("string array element: '"+ myArray[i] + "'");         
         myString += myArray[i];
      }      
      return myString;      
   }
   
   //-- private attibutes --
   private String title;
   private String aulast;
   private String aufirst;   
   private String issn;
   private String eissn;
   private String coden;
   private String isbn;
   private String stitle;
   private String atitle;
   
//   private String description;
//   private String[] subject;
//   private String[] classification;
//   private String[] status;
//   private String[] contribrole;
//   private String[] contribentity;
//   private String[] lang;
//   private String[] resourcetype;
//   private String[] keyword;
   
   private String baseResolver;
   
   /* OpenURL construction attributes */

   private static final String basePid = "pid=";
   
//    pid tags
   //private static final String titleTag = "title=";
   private static final String auLastTag = "aulast=";
   private static final String auFirstTag = "aufirst=";
   private static final String issnTag = "issn=";
   private static final String eissnTag = "eissn=";   
   private static final String codenTag = "coden=";   
   private static final String isbnTag = "isbn=";      
   private static final String titleTag = "title=";   
   private static final String stitleTag = "stitle=";
   private static final String atitleTag = "atitle="; 

//   private static final String beginTitleTag = "<title>";
//   private static final String endTitleTag = "</title>";
//   private static final String beginDescTag = "<desc>";
//   private static final String endDescTag = "</desc>";
//   private static final String beginSubjectTag = "<subject>";
//   private static final String endSubjectTag = "</subject>";
//   private static final String beginClassificationTag = "<classification>";
//   private static final String endClassificationTag = "</classification>";
//   private static final String beginStatusTag = "<status>";
//   private static final String endStatusTag = "</status>";
//   private static final String beginContribRoleTag = "<contribrole>";
//   private static final String endContribRoleTag = "</contribrole>";
//   private static final String beginContribEntityTag = "<contribentity>";
//   private static final String endContribEntityTag = "</contribentity>";
//   private static final String beginLangTag = "<lang>";
//   private static final String endLangTag = "</lang>";
//   private static final String beginResourcetypeTag = "<resourcetype>";
//   private static final String endResourcetypeTag = "</resourcetype>";
//   private static final String beginKeywordTag = "<keyword>";
//   private static final String endKeywordTag = "</keyword>";   
   
}
