package org.mdcog.util.transfer;

import org.mdcog.MdcException;

/**
 * This Exception wraps any exception thrown during the transfer process
 */
public class TransferException extends MdcException
{

    /**
     * Creates new <code>TransferException</code> with null as its detail
     * message. The cause is not initialized, and may subsequently be
     * initialized by a call to Throwable.initCause(java.lang.Throwable).
     */
    public TransferException()
    {
    }

    /**
     * Creates new <code>TransferException</code> with the specified detail
     * message. The cause is not initialized, and may subsequently be
     * initialized by a call to Throwable.initCause(java.lang.Throwable).
     * 
     * @param message the detail message.
     */
    public TransferException(String message)
    {
        super(message);
    }

    /**
     * Creates new <code>TransferException</code> with the specified detail
     * message and cause
     * 
     * @param message the detail message (which is saved for later retrieval by
     *        the Throwable.getMessage() method).
     * @param cause the cause (which is saved for later retrieval by the
     *        Throwable.getCause() method). A null value is permitted, and
     *        indicates that the cause is nonexistent or unknown.
     */
    public TransferException(String message, Throwable cause)
    {
        super(message, cause);
    }

    /**
     * Constructs a new exception with the specified cause and a detail message
     * of <code>(cause == null ? null : cause.toString())</code> which typically contains the
     * class and detail message of cause). This constructor is useful for
     * exceptions that are little more than wrappers for other throwables
     * 
     * @param cause the cause (which is saved for later retrieval by the
     *        Throwable.getCause() method). A null value is permitted, and
     *        indicates that the cause is nonexistent or unknown.
     */
    public TransferException(Throwable cause)
    {
        super(cause);
    }
}
